-- Name: FuelGaugeSignal
-- Author: RedFoxModding
-- Version: 1.0.0.0
-- Date: Feb. 2021

FuelGaugeSignal = {}
FuelGaugeSignal.overlays = {}
FuelGaugeSignal.MOD_NAME = g_currentModName
FuelGaugeSignal.mediaFilePath = g_currentModDirectory

if FuelGaugeSignal.overlays[1] == nil then
	table.insert(FuelGaugeSignal.overlays,createImageOverlay(FuelGaugeSignal.mediaFilePath .. "hud/SignalDXT5.dds"))
	setOverlayColor(FuelGaugeSignal.overlays[1], 1, 0, 0, 0.6)
	print("FuelGaugeSignal: prepared overlay")
end

function FuelGaugeSignal.prerequisitesPresent(specializations)
  return true
end

function FuelGaugeSignal.registerEventListeners(vehicleType)
  SpecializationUtil.registerEventListener(vehicleType, "onUpdate", FuelGaugeSignal)
  SpecializationUtil.registerEventListener(vehicleType, "onLoad", FuelGaugeSignal)
end

function FuelGaugeSignal:onLoad(savegame)
end

function FuelGaugeSignal:onUpdate(dt)
	if self:getIsActive() then
		local spec = self.spec_motorized
		if spec ~= nil then
			if spec.consumersByFillTypeName.diesel ~= nil then
				local fuelLevelPercentage = self:getFillUnitFillLevelPercentage(tonumber(spec.consumersByFillTypeName.diesel.fillUnitIndex))
				if fuelLevelPercentage < 0.1 then
					--if vehicle has no fuelGaugeIconElement nothing will be rendered (Train, Conveyorbelt)
					if g_currentMission.inGameMenu.hud.speedMeter.fuelGaugeIconElement.overlay.x ~= nil then
						local fuelGaugeIconX = g_currentMission.inGameMenu.hud.speedMeter.fuelGaugeIconElement.overlay.x
						local fuelGaugeIconY = g_currentMission.inGameMenu.hud.speedMeter.fuelGaugeIconElement.overlay.y
						local Width = g_currentMission.inGameMenu.hud.speedMeter.fuelGaugeIconElement.overlay.defaultWidth
						local Height = g_currentMission.inGameMenu.hud.speedMeter.fuelGaugeIconElement.overlay.defaultHeight
						renderOverlay(FuelGaugeSignal.overlays[1], fuelGaugeIconX, fuelGaugeIconY, Width, Height)
					end
				end
			end
		end
	end
end			